From c1b34d7b31c11ec58b1c5ce550c532d7afea54dc Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 23 2021 03:17:40 +0000
Subject: [PATCH 2166/2232] Merge pull request #753 from dtolnay/ptrcast


Handle pointer cast of non-ffi-safe pointer target types
---

diff --git a/macro/src/expand.rs b/macro/src/expand.rs
index 6d414c3..0a88a04 100644
--- a/macro/src/expand.rs
+++ b/macro/src/expand.rs
@@ -512,6 +512,13 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                 },
                 _ => quote!(#var),
             },
+            Type::Ptr(ty) => {
+                if types.is_considered_improper_ctype(&ty.inner) {
+                    quote!(#var.cast())
+                } else {
+                    quote!(#var)
+                }
+            }
             Type::Str(_) => quote!(::cxx::private::RustStr::from(#var)),
             Type::SliceRef(ty) => match ty.mutable {
                 false => quote!(::cxx::private::RustSlice::from_ref(#var)),
@@ -608,6 +615,13 @@ fn expand_cxx_function_shim(efn: &ExternFn, types: &Types) -> TokenStream {
                     }
                     _ => call,
                 },
+                Type::Ptr(ty) => {
+                    if types.is_considered_improper_ctype(&ty.inner) {
+                        quote!(#call.cast())
+                    } else {
+                        call
+                    }
+                }
                 Type::Str(_) => quote!(#call.as_str()),
                 Type::SliceRef(slice) => {
                     let inner = &slice.inner;
@@ -1572,6 +1586,15 @@ fn expand_extern_type(ty: &Type, types: &Types, proper: bool) -> TokenStream {
                 _ => quote!(#ty),
             }
         }
+        Type::Ptr(ty) => {
+            if proper && types.is_considered_improper_ctype(&ty.inner) {
+                let mutability = ty.mutability;
+                let constness = ty.constness;
+                quote!(*#mutability #constness ::std::ffi::c_void)
+            } else {
+                quote!(#ty)
+            }
+        }
         Type::Str(_) => quote!(::cxx::private::RustStr),
         Type::SliceRef(_) => quote!(::cxx::private::RustSlice),
         _ => quote!(#ty),

